;**********************************************************************
;                                                                     *
;    Filename:	    	melody8.asm			                          *
;                                                                     *
;**********************************************************************

	list      p=12F683
	#include <p12F683.inc>
	#include "term8.inc"
	errorlevel  -302

	__CONFIG   _FCMEN_OFF & _IESO_OFF & _CP_OFF & _CPD_OFF & _BOD_ON & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT 

; ***** fohñrbg蓖 *****
SOUND		EQU	0	; `go

; ***** VARIABLE DEFINITIONS ******
; in common area(max 16 bytes!)
w_temp		EQU     0x70 		; 荞ݎ w WX^̃Z[uEGA 
status_temp	EQU     0x71		; 荞ݎ sataus WX^̃Z[uEGA

; ***** autoϐ̂悤Ɉϐ@*****
_a		EQU	0x72
_b		EQU	0x73
_c		EQU	0x74
_h		EQU	0x75
_l		EQU	0x76
_w		EQU	0x77

; *****	ʕϐ *****  
_low		EQU	0x78
_high		EQU	0x79
p_low		EQU	0x7a
p_high		EQU	0x7b
time		EQU	0x7c			; Ԃ̃obt@
amp			EQU	0x7d			; ʂ̃obt@
playing		EQU	0x7e			; ttO
restNote	EQU	0x7f			; xtO


; ***** p[IEZbg *****

	ORG     0x000             ; processor reset vector
	goto    main              ; go to beginning of program

; ***** 荞݃xN^ *****

	ORG     0x004             ; p̃Rg̓}CN`bvЂ̃ev[g
	movwf   w_temp            ; save off current W register contents
	movf	STATUS,w          ; move status register into W register
	movwf	status_temp       ; save off contents of STATUS register

	bcf	PIR1,TMR1IF			  ; timer 1 int. flag clear
	clrf	playing

	movf    status_temp,w     ; retrieve copy of STATUS register
	movwf	STATUS            ; restore pre-isr STATUS register contents
	swapf   w_temp,f
	swapf   w_temp,w          ; restore pre-isr W register contents
	retfie                    ; return from interrupt

; ***** vO{ *****

main
	movlw	h'20'			; ϐNA
	movwf	FSR
	movlw	h'60'			; 20h  7Fh
fregclr
	clrf	INDF
	incf	FSR,f
	addlw	h'ff'			; w--	
	btfss	STATUS,Z
	goto	fregclr

	bsf	STATUS,RP0			; bank 1
clock_check
	btfss	OSCCON,HTS		; NbN̈҂
	goto	clock_check
	movlw	b'01110000'		; INTRCOSC 8MHz
	movwf	OSCCON
	clrf	ANSEL			; ADRo[^B
	movlw	b'00111010'		; 0:OUTPUT 1:CIN 2:COUT 3:reset
	movwf	TRISIO			; o͂̊蓖
	
	movlw	b'10010000'		; d̐ݒ͈͂knvɐݒ
	movwf	VRCON
	clrf	EEADR			; ddoqnl̓ǂݍ݃AhX̏
	bsf	PIE1,TMR1IE			; ^C}1荞݃Cl[u
	bcf	STATUS,RP0			; bank 0

	movlw	b'00000011'		; Rp[^̋@\ݒ
	movwf	CMCON0
	movlw	b'00111010'		; ^C}1̃NbNOtNX^ɁA1/8
	movwf	T1CON
	
main_loop
	btfsc	playing,0		; tH
	goto	sound_job		; sound_job ܂ňꏄɖ{̃fBCȊO 16 clock 
	
	bsf	STATUS,RP0			; bank 1
	bsf	EECON1,RD			; ddoqnl̉ʂǂݍ
	movf	EEDATA,w
	movwf	_l

	incf	EEADR,f
	bsf	EECON1,RD			; ddoqnl̏ʂǂݍ
	movf	EEDATA,w
	movwf	_h
	iorwf	_l,w			; [`FbN
	btfsc	STATUS,Z
	goto	restSet			; [Ȃ΋xtOZbg

	clrf	restNote
	movf	_l,w			; Zbg
	movwf	p_low
	movf	_h,w
	movwf	p_high
	goto	nextMember

restSet
	bsf	restNote,0
nextMember
	incf	EEADR,f
	bsf	EECON1,RD			; ddoqnl玝Ԃǂݍ
	movf	EEDATA,w
	movwf	time
	btfsc	STATUS,Z
	sleep					; [ȂΉtIAX[vԂ

	incf	EEADR,f
	bsf	EECON1,RD			; ddoqnl特ʂǂݍ
	movf	EEDATA,w
	movwf	amp
	btfsc	restNote,0
	goto	timeSet

	movlw	b'10100000'		; xłȂΊdݒ
	addwf	amp,w
	movwf	VRCON
	
timeSet
	incf	EEADR,f			; ̉f[^
	movf	time,w			; ^C}1̐ݒlvZ
	movwf	_l
	clrf	_h
	call	mult80			; (_low _high) = 80*(_l _h)

	bcf	STATUS,RP0			; bank 0
	bcf	T1CON,TMR1ON		; ^C}1ꎞ~
	comf	_low,w
	movwf	TMR1L
	comf	_high,w
	movwf	TMR1H
	bsf	T1CON,TMR1ON		; ^C}1̓ĊJ
	movlw	b'11000000'		; 荞݂
	movwf	INTCON
	bsf	playing,0

	bsf	STATUS,RP0			; bank 1
	movlw	b'10100000'		; d0ɂ
	movwf	VRCON
	bcf	STATUS,RP0			; bank 0
	
sound_job
	movf	p_low,w			; ݒ
	movwf	_low			; 
	movf	p_high,w		;
	movwf	_high			; 
	call	set_term		; ʂ̃fBC
	movlw	.1				; Mo͂𔽓]
	xorwf	GPIO,f
	goto	main_loop 
;
; ***** 16bit Z[` *****
;	_high _low += _h _l
;
add16
	movf	_l,w
	addwf	_low,f
	btfsc	STATUS,C
	incf	_high,f
	movf	_h,w
	addwf	_high,f
	return
;
; *****@80{ *****
;(_low _high) = 80*(_l _h)
;80 = 32 + 8
;
mult80
	clrf	_low		; result clear
	clrf	_high
	bcf	STATUS,C
	rlf	_l,f		;*2
	rlf	_h,f

	bcf	STATUS,C
	rlf	_l,f		;*4
	rlf	_h,f

	bcf	STATUS,C
	rlf	_l,f		;*8
	rlf	_h,f
	call	add16
	
	bcf	STATUS,C
	rlf	_l,f		;*16
	rlf	_h,f
	
	bcf	STATUS,C
	rlf	_l,f		;*32
	rlf	_h,f
	call	add16
	return

; ***** i_low _highjŒ߂fBC ***** 
;
;case (0 < _low) && (_high == 0) 
;1+1+2+(_low-1)*(1+2)+2+2+1+1+2
;=3*_low + 9
;
;case (_low == 0) && (0 < _high)
;1+2+(_high-1)*(1+2+1+255*(1+2)+2+2)+1+1+2
;=773*_high - 766
;
;case (0 < _low) && (0 < _high)
;1+1+2+(_low-1)*(1+2)+2+2+1+(_high-1)*(1+2+1+255*(1+2)+2+2)+1+1+2
;=773*high + 3*_low - 764
;
set_term
	movf	_low,f		;1
	btfss	STATUS,Z	;1(2)
	goto	sq00		;2
sq10
	movf	_high,f		;1
	btfsc	STATUS,Z	;1(2)
	return				;2
	decf	_high,f		;1
sq00
	decfsz	_low,f		;1(2)
	goto	sq00		;2
	goto	sq10		;2
;
; **** initialize eeprom locations ****
;		f[^
; pitch(low) pitch(high) time amp
;
	ORG	0x2100

	DE	low TA1,high TA1,.40,.6			; [c@g̃sAmt20Ԃ
	DE	low TA2,high TA2,.40,.12
	DE	low TC2S,high TC2S,.40,.8

	DE	low TE2,high TE2,.60,.10
	DE	low TD2,high TD2,.20,.8
	DE	low TD2,high TD2,.80,.8

	DE	0,0,.40,0
	DE	low TD2,high TD2,.40,.8
	DE	low TD3,high TD3,.40,.15
	DE	low TC3,high TC3,.20,.15
	DE	low TB2,high TB2,.20,.12

	DE	low TA2,high TA2,.60,.8
	DE	low TG2,high TG2,.20,.8
	DE	low TG2,high TG2,.80,.6

	DE	0,0,.40,0
	DE	low TG2,high TG2,.40,.6
	DE	low TA2,high TA2,.20,.6
	DE	low TG2,high TG2,.20,.6
	DE	low TF2,high TF2,.20,.6
	DE	low TE2,high TE2,.20,.6

	DE	low TD2,high TD2,.40,.6
	DE	low TC2S,high TC2S,.40,.8
	DE	low TB1,high TB1,.100,.12

	DE	low TA1,high TA1,.20,.6
	DE	low TE2,high TE2,.20,.8
	DE	low TC2S,high TC2S,.20,.6
	DE	low TG2,high TG2,.20,.12
	DE	low TE2,high TE2,.20,.8
	DE	low TB2,high TB2,.20,.8
	DE	low TA2,high TA2,.20,.8

	DE	low TG2,high TG2,.20,.12
	DE	low TF2,high TF2,.20,.8
	DE	low TB2,high TB2,.20,.12
	DE	low TA2,high TA2,.20,.8
	DE	low TA2,high TA2,.80,.12
	DE	0,0,0,0							; stopper
	

		END
